#!/usr/bin/python3

import sys
import json
import i3ipc

sway = i3ipc.Connection()

def show(name):
	print(json.dumps({
		"text": name[:2].upper(),
		"alt": name,
	}), file=sys.stdout)
	sys.stdout.flush()

# this script works with only one keyboard. we find it's ID.
# it should have more than one layout
for input_dev in sway.get_inputs():
	if input_dev.type == 'keyboard' and len(input_dev.xkb_layout_names) > 1:
		keyboard = input_dev.identifier
		show(input_dev.xkb_active_layout_name)
		break

def on_input(sway, event):
	if event.input.identifier == keyboard and event.change == "xkb_layout":
		show(event.input.xkb_active_layout_name)

def on_shutdown(sway, event):
	sway.main_quit()

sway.on(i3ipc.Event.INPUT,            on_input)
sway.on(i3ipc.Event.SHUTDOWN,         on_shutdown)
sway.on(i3ipc.Event.SHUTDOWN_RESTART, on_shutdown)
sway.on(i3ipc.Event.SHUTDOWN_EXIT,    on_shutdown)
sway.on(i3ipc.Event.BARCONFIG_UPDATE, on_shutdown)
sway.main()
